| Face Engine SDK 4.7.0 A face detection, recognition and tracking engine.

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | List of all members
fsdk::IFaceEngine Struct Referenceabstract
SDK core interfaces

Root LUNA SDK object interface. More...

`#include <IFaceEngine.h>`

Inheritance diagram for fsdk::IFaceEngine:

## Public Member Functions
virtual IDetector * | createDetector (ObjectDetectorClassType type=FACE_DET_DEFAULT, RecognitionMode mode=RecognitionMode::RM_RGB) noexcept=0
| Creates a detector of given type. More...
virtual IHumanDetector * | createHumanDetector () noexcept=0
| Creates a human detector. More...
virtual IHeadPoseEstimator * | createHeadPoseEstimator () noexcept=0
| Creates Head pose estimator. More...
virtual IOverlapEstimator * | createOverlapEstimator () noexcept=0
| Creates Overlap estimator. More...
virtual IChildEstimator * | createChildEstimator () noexcept=0
| Creates Child estimator. More...
virtual IAGSEstimator * | createAGSEstimator () noexcept=0
| Creates AGS estimator. More...
virtual IHeadAndShouldersLivenessEstimator * | createHeadAndShouldersLivenessEstimator () noexcept=0
| Creates HeadAndShouldersLiveness estimator. More...
virtual IAttributeEstimator * | createAttributeEstimator () noexcept=0
| Creates Attribute estimator. More...
virtual IQualityEstimator * | createQualityEstimator () noexcept=0
| Creates Quality estimator. More...
virtual IBlackWhiteEstimator * | createBlackWhiteEstimator () noexcept=0
| Creates Black/White estimator. More...
virtual ILivenessDepthEstimator * | createDepthEstimator () noexcept=0
| Creates Liveness Depth estimator. More...
virtual ILivenessIREstimator * | createIREstimator () noexcept=0
| Creates Liveness Infrared estimator. More...
virtual ISmileEstimator * | createSmileEstimator () noexcept=0
| Creates Smile estimator. More...
virtual IMouthEstimator * | createMouthEstimator () noexcept=0
| Creates Mouth estimator. More...
virtual IMedicalMaskEstimator * | createMedicalMaskEstimator () noexcept=0
| Creates MedicalMask estimator. More...
virtual ILivenessFlyingFacesEstimator * | createLivenessFlyingFacesEstimator () noexcept=0
| Creates LivenessFlyingFaces estimator. More...
virtual ILivenessFlowEstimator * | createFaceFlowEstimator () noexcept=0
| Creates Liveness flow estimator. More...
virtual ILivenessRGBMEstimator * | createLivenessRGBMEstimator () noexcept=0
| Creates Liveness RGBM estimator. More...
virtual ILivenessFPREstimator * | createLivenessFPREstimator () noexcept=0
| Creates LivenessFPR estimator. More...
virtual IEyeEstimator * | createEyeEstimator (RecognitionMode mode=RecognitionMode::RM_RGB) noexcept=0
| Creates Eye estimator. More...
virtual IEmotionsEstimator * | createEmotionsEstimator () noexcept=0
| Creates Emotions estimator. More...
virtual IGazeEstimator * | createGazeEstimator (RecognitionMode mode=RecognitionMode::RM_RGB) noexcept=0
| Creates Gaze estimator. More...
virtual IGlassesEstimator * | createGlassesEstimator () noexcept=0
| Creates Glasses estimator. More...
virtual IBestShotQualityEstimator * | createBestShotQualityEstimator () noexcept=0
| Creates BestShotQuality estimator. More...
virtual ICredibilityCheckEstimator * | createCredibilityCheckEstimator () noexcept=0
| Creates CredibilityCheck estimator. More...
virtual IFacialHairEstimator * | createFacialHairEstimator () noexcept=0
| Creates FacialHair estimator. More...
virtual IDescriptor * | createDescriptor (uint32_t version=0) noexcept=0
| Creates Descriptor. More...
virtual IDescriptor * | createDescriptor (fsdk::IArchive *archive, uint32_t flags=0) noexcept=0
| Creates and loads Descriptor from Archive. More...
virtual IDescriptorBatch * | createDescriptorBatch (int32_t size, uint32_t version=0) noexcept=0
| Creates Batch of descriptors. More...
virtual IDescriptorExtractor * | createExtractor (uint32_t version=0) noexcept=0
| Creates descriptor extractor. More...
virtual IDescriptorMatcher * | createMatcher (uint32_t version=0) noexcept=0
| Creates descriptor matcher. More...
virtual IIndexBuilder * | createIndexBuilder (const size_t capacity=0, uint32_t version=0) noexcept=0
| Creates index builder. More...
virtual ResultValue< FSDKError, IDenseIndex * > | loadDenseIndex (const char *indexPath) noexcept=0
| Loads dense index. More...
virtual ResultValue< FSDKError, IDynamicIndex * > | loadDynamicIndex (const char *indexPath) noexcept=0
| Loads dynamic index. More...
virtual IWarper * | createWarper () noexcept=0
| Creates warper. More...
virtual IHumanWarper * | createHumanWarper () noexcept=0
| Creates human warper. More...
virtual IAsyncContext * | createAsyncContext (const int8_t threadCount) noexcept=0
| Creates async context. More...
virtual FaceEngineEdition | getFaceEngineEdition () const noexcept=0
| Get LUNA SDK ditribution edition. More...
virtual void | setDataDirectory (const char *path) noexcept=0
| Sets data directory. More...
virtual const char * | getDataDirectory () const noexcept=0
| Gets data directory. More...
virtual void | setSettingsProvider (ISettingsProvider *provider) noexcept=0
| Sets settings provider. More...
virtual void | setRuntimeSettingsProvider (ISettingsProvider *provider) noexcept=0
| Sets runtime settings provider. More...
virtual ISettingsProvider * | getSettingsProvider () const noexcept=0
| Gets settings provider. More...
virtual ISettingsProvider * | getRuntimeSettingsProvider () const noexcept=0
| Gets runtime settings provider. More...
virtual ILicense * | getLicense () const noexcept=0
| Get current License object, which was set for FaceEngine object. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

Root LUNA SDK object interface.

Note
  Face Engine also implements factory interface so all usual factory options apply.

## Member Function Documentation

virtual IAGSEstimator* fsdk::IFaceEngine::createAGSEstimator | ( |  | ) |
| pure virtual noexcept

Creates AGS estimator.

Returns
  AGS estimator if succeeded, null if failed.

virtual IAsyncContext* fsdk::IFaceEngine::createAsyncContext | ( | const int8_t | threadCount | ) |
| pure virtual noexcept

Creates async context.

Parameters

  threadCount | Count of threads to create for internal thread pool.

Returns
  IAsyncContext if succeed, null if failed.

virtual IAttributeEstimator* fsdk::IFaceEngine::createAttributeEstimator | ( |  | ) |
| pure virtual noexcept

Creates Attribute estimator.

Returns
  Attribute estimator if succeed, null if failed.

virtual IBestShotQualityEstimator* fsdk::IFaceEngine::createBestShotQualityEstimator | ( |  | ) |
| pure virtual noexcept

Creates BestShotQuality estimator.

Returns
  BestShotQuality estimator if succeed, null if failed.

virtual IBlackWhiteEstimator* fsdk::IFaceEngine::createBlackWhiteEstimator | ( |  | ) |
| pure virtual noexcept

Creates Black/White estimator.

Returns
  Black/White estimator if succeed, null if failed.

virtual IChildEstimator* fsdk::IFaceEngine::createChildEstimator | ( |  | ) |
| pure virtual noexcept

Creates Child estimator.

Returns
  Child estimator if succeeded, null if failed.

virtual ICredibilityCheckEstimator* fsdk::IFaceEngine::createCredibilityCheckEstimator | ( |  | ) |
| pure virtual noexcept

Creates CredibilityCheck estimator.

Returns
  ICredibilityCheck estimator if succeed, null if failed.

virtual ILivenessDepthEstimator* fsdk::IFaceEngine::createDepthEstimator | ( |  | ) |
| pure virtual noexcept

Creates Liveness Depth estimator.

Returns
  Depth liveness estimator if succeed, null if failed.

virtual IDescriptor* fsdk::IFaceEngine::createDescriptor | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates Descriptor.

face descriptor will created by default, to create human descriptor pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 101

See Also
  fsdk::DescriptorVersion

Returns
  Descriptor if succeed, null if failed.

virtual IDescriptor* fsdk::IFaceEngine::createDescriptor | ( | fsdk::IArchive * | archive,
|  | uint32_t | flags = `0`
| ) |  |
| pure virtual noexcept

Creates and loads Descriptor from Archive.

Parameters

  archive | Archive with descriptor.
  flags | Archive flag.

Returns
  Descriptor if succeed, null if failed.

virtual IDescriptorBatch* fsdk::IFaceEngine::createDescriptorBatch | ( | int32_t | size,
|  | uint32_t | version = `0`
| ) |  |
| pure virtual noexcept

Creates Batch of descriptors.

face descriptor batch will be created by default, to create human descriptor batch you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 101

See Also
  fsdk::DescriptorVersion

Parameters

  [in] | size | - amount of descriptors in batch.
  [in] | version | - descriptor version in batch. If 0 - use dafault version from config.

Returns
  Batch if succeed, null if failed.

virtual IDetector* fsdk::IFaceEngine::createDetector | ( | ObjectDetectorClassType | type = `FACE_DET_DEFAULT`,
|  | RecognitionMode | mode = `RecognitionMode::RM_RGB`
| ) |  |
| pure virtual noexcept

Creates a detector of given type.

Parameters

  [in] | type | detector type. Supported types: FACE_DET_V1, FACE_DET_V2, FACE_DET_V3.
  [in] | RecognitionMode. | Determines which recognition mode to use: RM_RGB or RM_INFRA_RED.

Returns
  detector object if succeeded, null if failed.

virtual IEmotionsEstimator* fsdk::IFaceEngine::createEmotionsEstimator | ( |  | ) |
| pure virtual noexcept

Creates Emotions estimator.

Returns
  Emotions estimator if succeed, null if failed.

virtual IDescriptorExtractor* fsdk::IFaceEngine::createExtractor | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates descriptor extractor.

face descriptor extractor will created by default, to create human descriptor extractor descriptor you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 101

See Also
  fsdk::DescriptorVersion

Returns
  Descriptor extractor if succeed, null if failed.

virtual IEyeEstimator* fsdk::IFaceEngine::createEyeEstimator | ( | RecognitionMode | mode = `RecognitionMode::RM_RGB` | ) |
| pure virtual noexcept

Creates Eye estimator.

Parameters

  [in] | RecognitionMode. | Determines which recognition mode to use: RM_RGB or RM_INFRA_RED.

Returns
  Eye estimator if succeed, null if failed.

virtual ILivenessFlowEstimator* fsdk::IFaceEngine::createFaceFlowEstimator | ( |  | ) |
| pure virtual noexcept

Creates Liveness flow estimator.

Returns
  Liveness Flow estimator if succeed, null if failed.

Note
  This estimator is required only for liveness detection purposes.

virtual IFacialHairEstimator* fsdk::IFaceEngine::createFacialHairEstimator | ( |  | ) |
| pure virtual noexcept

Creates FacialHair estimator.

Returns
  IFacialHairEstimator estimator if succeed, null if failed.

virtual IGazeEstimator* fsdk::IFaceEngine::createGazeEstimator | ( | RecognitionMode | mode = `RecognitionMode::RM_RGB` | ) |
| pure virtual noexcept

Creates Gaze estimator.

Parameters

  [in] | RecognitionMode. | Determines which recognition mode to use: RM_RGB or RM_INFRA_RED.

Returns
  Gaze estimator if succeed, null if failed.

virtual IGlassesEstimator* fsdk::IFaceEngine::createGlassesEstimator | ( |  | ) |
| pure virtual noexcept

Creates Glasses estimator.

Returns
  Glasses estimator if succeed, null if failed.

virtual IHeadAndShouldersLivenessEstimator* fsdk::IFaceEngine::createHeadAndShouldersLivenessEstimator | ( |  | ) |
| pure virtual noexcept

Creates HeadAndShouldersLiveness estimator.

Returns
  HeadAndShouldersLiveness estimator if succeeded, null if failed.

virtual IHeadPoseEstimator* fsdk::IFaceEngine::createHeadPoseEstimator | ( |  | ) |
| pure virtual noexcept

Creates Head pose estimator.

Returns
  Head pose estimator if succeeded, null if failed.

virtual IHumanDetector* fsdk::IFaceEngine::createHumanDetector | ( |  | ) |
| pure virtual noexcept

Creates a human detector.

Returns
  detector object if succeeded, null if failed.

virtual IHumanWarper* fsdk::IFaceEngine::createHumanWarper | ( |  | ) |
| pure virtual noexcept

Creates human warper.

Returns
  Warper if succeed, null if failed.

virtual IIndexBuilder* fsdk::IFaceEngine::createIndexBuilder | ( | const size_t | capacity = `0`,
|  | uint32_t | version = `0`
| ) |  |
| pure virtual noexcept

Creates index builder.

face descriptor index builder will created by default, to create human index builder you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 101

See Also
  fsdk::DescriptorVersion

Parameters

  capacity | Allocate space for this much descriptors.

Returns
  Index builder if succeed, null if failed.

virtual ILivenessIREstimator* fsdk::IFaceEngine::createIREstimator | ( |  | ) |
| pure virtual noexcept

Creates Liveness Infrared estimator.

Returns
  Infrared liveness estimator if succeed, null if failed.

virtual ILivenessFlyingFacesEstimator* fsdk::IFaceEngine::createLivenessFlyingFacesEstimator | ( |  | ) |
| pure virtual noexcept

Creates LivenessFlyingFaces estimator.

Returns
  LivenessFlyingFaces estimator if succeed, null if failed.

virtual ILivenessFPREstimator* fsdk::IFaceEngine::createLivenessFPREstimator | ( |  | ) |
| pure virtual noexcept

Creates LivenessFPR estimator.

Returns
  LivenessFPR estimator if succeed, null if failed.

Note
  This estimator is required only for liveness detection purposes.

virtual ILivenessRGBMEstimator* fsdk::IFaceEngine::createLivenessRGBMEstimator | ( |  | ) |
| pure virtual noexcept

Creates Liveness RGBM estimator.

Returns
  Liveness RGBM estimator if succeed, null if failed.

Note
  This estimator is required only for liveness detection purposes.

virtual IDescriptorMatcher* fsdk::IFaceEngine::createMatcher | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates descriptor matcher.

face descriptor matcher will created by default, to create human descriptor matcher you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 101

See Also
  fsdk::DescriptorVersion

Returns
  Descriptor matcher if succeed, null if failed.

virtual IMedicalMaskEstimator* fsdk::IFaceEngine::createMedicalMaskEstimator | ( |  | ) |
| pure virtual noexcept

Creates MedicalMask estimator.

Returns
  MedicalMask estimator if succeed, null if failed.

virtual IMouthEstimator* fsdk::IFaceEngine::createMouthEstimator | ( |  | ) |
| pure virtual noexcept

Creates Mouth estimator.

Returns
  Mouth estimator if succeed, null if failed.

virtual IOverlapEstimator* fsdk::IFaceEngine::createOverlapEstimator | ( |  | ) |
| pure virtual noexcept

Creates Overlap estimator.

Returns
  Overlap estimator if succeeded, null if failed.

virtual IQualityEstimator* fsdk::IFaceEngine::createQualityEstimator | ( |  | ) |
| pure virtual noexcept

Creates Quality estimator.

Returns
  Quality estimator if succeed, null if failed.

virtual ISmileEstimator* fsdk::IFaceEngine::createSmileEstimator | ( |  | ) |
| pure virtual noexcept

Creates Smile estimator.

Returns
  Smile estimator if succeed, null if failed.

virtual IWarper* fsdk::IFaceEngine::createWarper | ( |  | ) |
| pure virtual noexcept

Creates warper.

Returns
  Warper if succeed, null if failed.

virtual const char* fsdk::IFaceEngine::getDataDirectory | ( |  | ) | const
| pure virtual noexcept

Gets data directory.

By default is set to "./data".

Returns
  path to data directory.

virtual FaceEngineEdition fsdk::IFaceEngine::getFaceEngineEdition | ( |  | ) | const
| pure virtual noexcept

Get LUNA SDK ditribution edition.

Returns
  Edition of LUNA SDK instance. Posible values:
  - CompleteEdition - full edition with all function.
  - FrontEndEdition - short edition with excluded descriptor functions. Extractor, matcher, descriptor, batch and index cannot be created.

virtual ILicense* fsdk::IFaceEngine::getLicense | ( |  | ) | const
| pure virtual noexcept

Get current License object, which was set for FaceEngine object.

Returns
  pointer to current license object, nullptr if no any license was set to.

virtual ISettingsProvider* fsdk::IFaceEngine::getRuntimeSettingsProvider | ( |  | ) | const
| pure virtual noexcept

Gets runtime settings provider.

Returns
  runtime settings provider.

virtual ISettingsProvider* fsdk::IFaceEngine::getSettingsProvider | ( |  | ) | const
| pure virtual noexcept

Gets settings provider.

Returns
  settings provider.

virtual ResultValue<FSDKError, IDenseIndex*> fsdk::IFaceEngine::loadDenseIndex | ( | const char * | indexPath | ) |
| pure virtual noexcept

Loads dense index.

Note
  Only indexes saved as dense are to be loaded as dense.

Parameters

  indexPath | Path to index to be loaded.

Returns
  One of the error codes specified by

See Also
  FSDKError and ptr to IDenseIndex object. On failure, its null.

virtual ResultValue<FSDKError, IDynamicIndex*> fsdk::IFaceEngine::loadDynamicIndex | ( | const char * | indexPath | ) |
| pure virtual noexcept

Loads dynamic index.

Note
  Only indexes saved as dynamic are to be loaded as dynamic.

Parameters

  indexPath | Path to index to be loaded.

Returns
  One of the error codes specified by

See Also
  FSDKError and ptr to IDynamicIndex object. On failure, its null.

virtual void fsdk::IFaceEngine::setDataDirectory | ( | const char * | path | ) |
| pure virtual noexcept

Sets data directory.

Parameters

  [in] | path | path to data directory.

virtual void fsdk::IFaceEngine::setRuntimeSettingsProvider | ( | ISettingsProvider * | provider | ) |
| pure virtual noexcept

Sets runtime settings provider.

Parameters

  [in] | provider | runtime settings provider.

virtual void fsdk::IFaceEngine::setSettingsProvider | ( | ISettingsProvider * | provider | ) |
| pure virtual noexcept

Sets settings provider.

Parameters

  [in] | provider | settings provider.

The documentation for this struct was generated from the following file:

- include/fsdk/IFaceEngine.h